<?php

/**
 * Class ReceiptModel
 */

class ReceiptModel extends ObjectModel
{
    public $id_chekonline_receipt;
    public $order_number;
    public $type;
    public $status;
    public $date_of_printing;
    public $title;
    public $content;

    public static $definition = array(
        'table' => 'chekonline_receipt',
        'primary' => 'id_chekonline_receipt',
        'multilang' => true,
        'fields' => array(
            'order_number' => array('type' => self::TYPE_STRING, 'size' => 20),
            'type' => array('type' =>  self::TYPE_INT),
            'status' => array('type' => self::TYPE_INT),
            'date_of_printing' => array('type' => self::TYPE_STRING, 'size' => 20),

            'title' => array('type' => self::TYPE_STRING, 'lang' => true, 'validate' => 'isGenericName','size' => 20 ),
            'content' => array('type' => self::TYPE_STRING, 'lang' => true, 'validate' => 'isGenericName', 'size' => 20),
        ),
    );

    /**
     * @param int $typeId
     * @param int $orderId
     * @return null|ReceiptModel
     */
    public static function getFromTypeAndOrder($typeId, $orderId)
    {
        $sql = "
                    SELECT id_chekonline_receipt FROM `"._DB_PREFIX_."chekonline_receipt`
                    WHERE `type` = {$typeId} AND `order_number` = '{$orderId}'
                ";
        $result = Db::getInstance()->getValue($sql);

        if ($result === false) {
            return null;
        }
        $result = intval($result);
        $receipt = new ReceiptModel($result);
        return $receipt;
    }

    /**
     * @param $startDate
     *
     * @return array
     */
    public static function getReceiptsForResend($startDate)
    {
        $sql = "
                    SELECT `id_chekonline_receipt` FROM `"._DB_PREFIX_."chekonline_receipt`
                    WHERE `status` = 0 AND `date_of_printing` >= '{$startDate}' ORDER BY `date_of_printing` DESC
                ";

        $result = Db::getInstance()->executeS($sql);

        $receipts = array();

        foreach ($result as $item) {
            $receipts[$item['id_chekonline_receipt']] = new ReceiptModel($item['id_chekonline_receipt']);
        }

        return $receipts;
    }
}